<template>
  <div class="container">
    <h1>Post page</h1>
    <div class="create-post">
        <label for="create-post">say something...</label>
        <input type="text" id="create-post" v-model= posts.form.text >
        <button v-on:click="createPost">Post</button>
    </div>
    <hr>
    <p class="error" v-if="error">{{error}}</p>
    <div class="posts-container">
        <div class="post"
            v-for="(post, index) in posts.list"
            v-bind:item="post"
            v-bind:index="index"
            v-bind:key="post._id"
            v-on:dblclick="deletePost(post._id)">
            {{ `${post.createdAt.getDate()} / ${post.createdAt.getMonth()} /${post.createdAt.getFullYear()}` }}
            <p class="text">{{ post.text }}</p>
        </div>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
export default {
  name: 'PostPage',
  data() {
      return {
          message : '',
          error: ''
      }
  },
    computed: {
    ...mapGetters([
      'posts'
    ])
  },
  created() {
    this.getList();
  },
  methods: {
      getList() {
        try {
          this.$store.dispatch('postModule/getList');
        } catch (error) {
          this.error = error;
        }
      },
      async createPost() {
        try {
          await this.$store.dispatch('postModule/storePost');
          this.getList();
        } catch (error) {
          this.error = error;
        }
          
      },
      async deletePost(id) {
        try {
          await this.$store.dispatch('postModule/deletePost', id);
          this.getList();
        } catch (error) {
          this.error = error;
        }
        
      }
  }
}
</script>

<style scoped>
div.container {
  max-width: 800px;
  margin: 0 auto;
}

p.error {
  border: 1px solid #ff5b5f;
  background-color: #ffc5c1;
  padding: 10px;
  margin-bottom: 15px;
}

div.post {
  position: relative;
  border: 1px solid #5bd658;
  background-color: #bcffb8;
  padding: 10px 10px 30px 10px;
  margin-bottom: 15px;
}

div.created-at {
  position: absolute;
  top: 0;
  left: 0;
  padding: 5px 15px 5px 15px;
  background-color: darkgreen;
  color: white;
  font-size: 13px;
}

p.text {
  font-size: 22px;
  font-weight: 700;
  margin-bottom: 0;
}
</style>